Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3876)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3883)
@@ -1694,32 +1760,28 @@
 
        kk = 0
-       DO  WHILE ( cg%zw(kk) <= zw(nzt-1) )
+       DO WHILE ( pg%zw(kk) <= zw(nzt-1) )
           kk = kk + 1
        ENDDO
        kctw = kk - 1
 
-       WRITE(9,"('kcto, kctw = ', 2(i3,2x))") kcto, kctw
-       FLUSH(9)
+       WRITE( 9, "('kcto, kctw = ', 2(i3,2x))" ) kcto, kctw
+       FLUSH( 9 )
        
-       icla = coarse_bound_aux(1)
-       icra = coarse_bound_aux(2)
-       jcsa = coarse_bound_aux(3)
-       jcna = coarse_bound_aux(4)
-       ALLOCATE( iflu(icla:icra) )
-       ALLOCATE( iflo(icla:icra) )
-       ALLOCATE( ifuu(icla:icra) )
-       ALLOCATE( ifuo(icla:icra) )
-       ALLOCATE( jflv(jcsa:jcna) )
-       ALLOCATE( jflo(jcsa:jcna) )
-       ALLOCATE( jfuv(jcsa:jcna) )
-       ALLOCATE( jfuo(jcsa:jcna) )       
-       ALLOCATE( kflw(0:cg%nz+1) )
-       ALLOCATE( kflo(0:cg%nz+1) )
-       ALLOCATE( kfuw(0:cg%nz+1) )
-       ALLOCATE( kfuo(0:cg%nz+1) )
-       ALLOCATE( ijkfc_u(0:cg%nz+1,jcsa:jcna,icla:icra) )
-       ALLOCATE( ijkfc_v(0:cg%nz+1,jcsa:jcna,icla:icra) )
-       ALLOCATE( ijkfc_w(0:cg%nz+1,jcsa:jcna,icla:icra) )
-       ALLOCATE( ijkfc_s(0:cg%nz+1,jcsa:jcna,icla:icra) )
+       ALLOCATE( iflu(ipla:ipra) )
+       ALLOCATE( iflo(ipla:ipra) )
+       ALLOCATE( ifuu(ipla:ipra) )
+       ALLOCATE( ifuo(ipla:ipra) )
+       ALLOCATE( jflv(jpsa:jpna) )
+       ALLOCATE( jflo(jpsa:jpna) )
+       ALLOCATE( jfuv(jpsa:jpna) )
+       ALLOCATE( jfuo(jpsa:jpna) )       
+       ALLOCATE( kflw(0:pg%nz+1) )
+       ALLOCATE( kflo(0:pg%nz+1) )
+       ALLOCATE( kfuw(0:pg%nz+1) )
+       ALLOCATE( kfuo(0:pg%nz+1) )
+       ALLOCATE( ijkfc_u(0:pg%nz+1,jpsa:jpna,ipla:ipra) )
+       ALLOCATE( ijkfc_v(0:pg%nz+1,jpsa:jpna,ipla:ipra) )
+       ALLOCATE( ijkfc_w(0:pg%nz+1,jpsa:jpna,ipla:ipra) )
+       ALLOCATE( ijkfc_s(0:pg%nz+1,jpsa:jpna,ipla:ipra) )
 
        ijkfc_u = 0
@@ -1730,10 +1792,13 @@
 !--    i-indices of u for each ii-index value
        istart = nxlg
-       DO  ii = icla, icra
+       DO  ii = ipla, ipra
 !
 !--       The parent and child grid lines do always match in x, hence we 
 !--       use only the local k,j-child-grid plane for the anterpolation.
+!--       However, icru still has to be stored separately as these index bounds
+!--       are passed as arguments to the interpolation and anterpolation 
+!--       subroutines.
           i = istart
-          DO WHILE ( coord_x(i) < cg%coord_x(ii) .AND. i < nxrg )
+          DO WHILE ( coord_x(i) < pg%coord_x(ii) .AND. i < nxrg )
              i = i + 1
           ENDDO
@@ -1743,15 +1808,15 @@
 !
 !--       Print out the index bounds for checking and debugging purposes
-          WRITE(9,"('pmci_define_index_mapping, ii, iflu, ifuu: ', 3(i4,2x))")    &
+          WRITE( 9, "('pmci_define_index_mapping, ii, iflu, ifuu: ', 3(i4,2x))" )                   &
                ii, iflu(ii), ifuu(ii)
-          FLUSH(9)
+          FLUSH( 9 )
        ENDDO
-       WRITE(9,*)
+       WRITE( 9, * )
 !
 !--    i-indices of others for each ii-index value
        istart = nxlg
-       DO  ii = icla, icra
+       DO  ii = ipla, ipra
           i = istart
-          DO  WHILE ( ( coord_x(i) + 0.5_wp * dx < cg%coord_x(ii) )  .AND.     &
+          DO WHILE ( ( coord_x(i) + 0.5_wp * dx < pg%coord_x(ii) )  .AND.     &
                       ( i < nxrg ) )
              i  = i + 1
@@ -1759,5 +1824,5 @@
           iflo(ii) = MIN( MAX( i, nxlg ), nxrg )
           ir = i
-          DO  WHILE ( ( coord_x(ir) + 0.5_wp * dx <= cg%coord_x(ii) + cg%dx )  &
+          DO WHILE ( ( coord_x(ir) + 0.5_wp * dx <= pg%coord_x(ii) + pg%dx )  &
                       .AND.  ( i < nxrg+1 ) )
              i  = i + 1
@@ -1768,18 +1833,21 @@
 !
 !--       Print out the index bounds for checking and debugging purposes
-          WRITE(9,"('pmci_define_index_mapping, ii, iflo, ifuo: ', 3(i4,2x))")    &
+          WRITE( 9, "('pmci_define_index_mapping, ii, iflo, ifuo: ', 3(i4,2x))" )                   &
                ii, iflo(ii), ifuo(ii)
-          FLUSH(9)
+          FLUSH( 9 )
        ENDDO
-       WRITE(9,*)
+       WRITE( 9, * )
 !
 !--    j-indices of v for each jj-index value
        jstart = nysg
-       DO  jj = jcsa, jcna
+       DO  jj = jpsa, jpna
 !
 !--       The parent and child grid lines do always match in y, hence we 
 !--       use only the local k,i-child-grid plane for the anterpolation.
+!--       However, jcnv still has to be stored separately as these index bounds 
+!--       are passed as arguments to the interpolation and anterpolation 
+!--       subroutines.
           j = jstart
-          DO WHILE ( coord_y(j) < cg%coord_y(jj) .AND. j < nyng )
+          DO WHILE ( coord_y(j) < pg%coord_y(jj) .AND. j < nyng )
              j = j + 1
           ENDDO
@@ -1789,22 +1857,20 @@
 !
 !--       Print out the index bounds for checking and debugging purposes
-          WRITE(9,"('pmci_define_index_mapping, jj, jflv, jfuv: ', 3(i4,2x))")    &
+          WRITE( 9, "('pmci_define_index_mapping, jj, jflv, jfuv: ', 3(i4,2x))" )                   &
                jj, jflv(jj), jfuv(jj)
           FLUSH(9)
        ENDDO
-       WRITE(9,*)
+       WRITE( 9, * )
 !
 !--    j-indices of others for each jj-index value
        jstart = nysg
-       DO  jj = jcsa, jcna
+       DO  jj = jpsa, jpna
           j = jstart
-          DO  WHILE ( ( coord_y(j) + 0.5_wp * dy < cg%coord_y(jj) )  .AND.     &
-                      ( j < nyng ) )
+          DO WHILE ( ( coord_y(j) + 0.5_wp * dy < pg%coord_y(jj) ) .AND. ( j < nyng ) )
              j  = j + 1
           ENDDO
           jflo(jj) = MIN( MAX( j, nysg ), nyng )
           jr = j
-          DO  WHILE ( ( coord_y(jr) + 0.5_wp * dy <= cg%coord_y(jj) + cg%dy )  &
-                      .AND.  ( j < nyng+1 ) )
+          DO WHILE ( ( coord_y(jr) + 0.5_wp * dy <= pg%coord_y(jj) + pg%dy ) .AND. ( j < nyng+1 ) )
              j  = j + 1
              jr = MIN( j, nyng )
@@ -1814,9 +1880,9 @@
 !
 !--       Print out the index bounds for checking and debugging purposes
-          WRITE(9,"('pmci_define_index_mapping, jj, jflo, jfuo: ', 3(i4,2x))")    &
+          WRITE( 9, "('pmci_define_index_mapping, jj, jflo, jfuo: ', 3(i4,2x))" )                   &
                jj, jflo(jj), jfuo(jj)
-          FLUSH(9)
+          FLUSH( 9 )
        ENDDO
-       WRITE(9,*)
+       WRITE( 9, * )
 !
 !--    k-indices of w for each kk-index value
@@ -1826,10 +1892,13 @@
        kflw(0) = 0
        kfuw(0) = 0
-       DO kk = 1, cg%nz+1
+       DO  kk = 1, pg%nz+1
 !
 !--       The parent and child grid lines do always match in z, hence we 
 !--       use only the local j,i-child-grid plane for the anterpolation.
+!--       However, kctw still has to be stored separately as these index bounds 
+!--       are passed as arguments to the interpolation and anterpolation 
+!--       subroutines.
           k = kstart
-          DO WHILE ( ( zw(k) < cg%zw(kk) )  .AND.  ( k < nzt+1 ) )
+          DO WHILE ( ( zw(k) < pg%zw(kk) )  .AND.  ( k < nzt+1 ) )
              k = k + 1
           ENDDO
@@ -1839,9 +1908,9 @@
 !
 !--       Print out the index bounds for checking and debugging purposes
-          WRITE(9,"('pmci_define_index_mapping, kk, kflw, kfuw: ', 4(i4,2x), 2(e12.5,2x))") &
-               kk, kflw(kk), kfuw(kk), nzt,  cg%zu(kk), cg%zw(kk)
-          FLUSH(9)
+          WRITE( 9, "('pmci_define_index_mapping, kk, kflw, kfuw: ', 4(i4,2x), 2(e12.5,2x))" )      &
+               kk, kflw(kk), kfuw(kk), nzt,  pg%zu(kk), pg%zw(kk)
+          FLUSH( 9 )
        ENDDO
-       WRITE(9,*)
+       WRITE( 9, * )
 !
 !--    k-indices of others for each kk-index value
@@ -1852,11 +1921,11 @@
 !--    Note that anterpolation index limits are needed also for the top boundary 
 !--    ghost cell level because they are used also in the interpolation.
-       DO  kk = 1, cg%nz+1
+       DO  kk = 1, pg%nz+1
           k = kstart
-          DO  WHILE ( ( zu(k) < cg%zw(kk-1) )  .AND.  ( k <= nzt ) )
+          DO WHILE ( ( zu(k) < pg%zw(kk-1) )  .AND.  ( k <= nzt ) )
              k = k + 1
           ENDDO
           kflo(kk) = MIN( MAX( k, 1 ), nzt + 1 )
-          DO  WHILE ( ( zu(k) <= cg%zw(kk) )  .AND.  ( k <= nzt+1 ) )
+          DO WHILE ( ( zu(k) <= pg%zw(kk) )  .AND.  ( k <= nzt+1 ) )
              k = k + 1
              IF ( k > nzt + 1 ) EXIT  ! This EXIT is to prevent zu(k) from flowing over.
@@ -1866,26 +1935,28 @@
        ENDDO
 !
-!--    Set the k-index bounds separately for the parent-grid cells cg%nz and cg%nz+1       
+!--    Set the k-index bounds separately for the parent-grid cells pg%nz and pg%nz+1       
 !--    although they are not actually needed.
-       kflo(cg%nz)   = nzt+1    
-       kfuo(cg%nz)   = nzt+kgsr 
-       kflo(cg%nz+1) = nzt+kgsr 
-       kfuo(cg%nz+1) = nzt+kgsr 
+!  WHY IS THIS LIKE THIS? REVISE WITH CARE.
+       kflo(pg%nz)   = nzt+1    
+       kfuo(pg%nz)   = nzt+kgsr 
+       kflo(pg%nz+1) = nzt+kgsr 
+       kfuo(pg%nz+1) = nzt+kgsr 
 !
 !--    Print out the index bounds for checking and debugging purposes
-       DO  kk = 1, cg%nz+1
-          WRITE(9,"('pmci_define_index_mapping, kk, kflo, kfuo: ', 4(i4,2x), 2(e12.5,2x))") &
-               kk, kflo(kk), kfuo(kk), nzt,  cg%zu(kk), cg%zw(kk)
-          FLUSH(9)
+       DO  kk = 1, pg%nz+1
+          WRITE( 9, "('pmci_define_index_mapping, kk, kflo, kfuo: ', 4(i4,2x), 2(e12.5,2x))" )      &
+               kk, kflo(kk), kfuo(kk), nzt,  pg%zu(kk), pg%zw(kk)
+          FLUSH( 9 )
        ENDDO
-       WRITE(9,*)
+       WRITE( 9, * )
 !
 !--    Precomputation of number of fine-grid nodes inside parent-grid cells.
 !--    Note that ii, jj, and kk are parent-grid indices. 
-!--    This information is needed in anterpolation and in reversibility 
-!--    correction in interpolation. 
-       DO  ii = icla, icra
-          DO  jj = jcsa, jcna
-             DO kk = 0, cg%nz+1
+!--    This information is needed in the anterpolation. 
+!--    The indices for wall_flags_0 (kw,jw,iw) must be limited to the range 
+!--    [-1,...,nx/ny/nzt+1] in order to avoid zero values on the outer ghost nodes.
+       DO  ii = ipla, ipra
+          DO  jj = jpsa, jpna
+             DO  kk = 0, pg%nz+1
 !
 !--             u-component
@@ -1896,5 +1967,5 @@
                       DO  k = kflo(kk), kfuo(kk)
                          kw = MIN( k, nzt+1 )                
-                         ijkfc_u(kk,jj,ii) = ijkfc_u(kk,jj,ii)                  &
+                         ijkfc_u(kk,jj,ii) = ijkfc_u(kk,jj,ii)                                      &
                               + MERGE( 1, 0, BTEST( wall_flags_0(kw,jw,iw), 1 ) )
                       ENDDO
@@ -1909,5 +1980,5 @@
                       DO  k = kflo(kk), kfuo(kk)
                          kw = MIN( k, nzt+1 )                                        
-                         ijkfc_v(kk,jj,ii) = ijkfc_v(kk,jj,ii)                  &
+                         ijkfc_v(kk,jj,ii) = ijkfc_v(kk,jj,ii)                                      &
                               + MERGE( 1, 0, BTEST( wall_flags_0(kw,jw,iw), 2 ) )
                       ENDDO
@@ -1922,5 +1993,5 @@
                       DO  k = kflo(kk), kfuo(kk)
                          kw = MIN( k, nzt+1 )
-                         ijkfc_s(kk,jj,ii) = ijkfc_s(kk,jj,ii)                  &
+                         ijkfc_s(kk,jj,ii) = ijkfc_s(kk,jj,ii)                                      &
                               + MERGE( 1, 0, BTEST( wall_flags_0(kw,jw,iw), 0 ) )
                       ENDDO
@@ -1935,6 +2006,6 @@
                       DO  k = kflw(kk), kfuw(kk)
                          kw = MIN( k, nzt+1 )
-                         ijkfc_w(kk,jj,ii) = ijkfc_w(kk,jj,ii) + MERGE( 1, 0,   &
-                              BTEST( wall_flags_0(kw,jw,iw), 3 ) )
+                         ijkfc_w(kk,jj,ii) = ijkfc_w(kk,jj,ii)                                      &
+                              + MERGE( 1, 0, BTEST( wall_flags_0(kw,jw,iw), 3 ) )
                       ENDDO
                    ENDDO
@@ -1956,41 +2027,36 @@
 !
 !--    Determine and store the PE-subdomain dependent index bounds
-       IF  ( bc_dirichlet_l )  THEN
-          iclw = icl + 1
+       IF ( bc_dirichlet_l )  THEN
+          iplw = ipl + 1
        ELSE
-          iclw = icl - 1
-       ENDIF
-
-       IF  ( bc_dirichlet_r )  THEN
-          icrw = icr - 1
+          iplw = ipl - 1
+       ENDIF
+
+       IF ( bc_dirichlet_r )  THEN
+          iprw = ipr - 1
        ELSE
-          icrw = icr + 1
-       ENDIF
-
-       IF  ( bc_dirichlet_s )  THEN
-          jcsw = jcs + 1
+          iprw = ipr + 1
+       ENDIF
+
+       IF ( bc_dirichlet_s )  THEN
+          jpsw = jps + 1
        ELSE
-          jcsw = jcs - 1
-       ENDIF
-
-       IF  ( bc_dirichlet_n )  THEN
-          jcnw = jcn - 1
+          jpsw = jps - 1
+       ENDIF
+
+       IF ( bc_dirichlet_n )  THEN
+          jpnw = jpn - 1
        ELSE
-          jcnw = jcn + 1
-       ENDIF
-    
-       coarse_bound_w(1) = iclw
-       coarse_bound_w(2) = icrw
-       coarse_bound_w(3) = jcsw
-       coarse_bound_w(4) = jcnw
+          jpnw = jpn + 1
+       ENDIF
 !
 !--    Left and right boundaries.
-       ALLOCATE( workarrc_lr(0:cg%nz+1,jcsw:jcnw,0:2) )
+       ALLOCATE( workarr_lr(0:pg%nz+1,jpsw:jpnw,0:2) )
 !
 !--    South and north boundaries.
-       ALLOCATE( workarrc_sn(0:cg%nz+1,0:2,iclw:icrw) )
+       ALLOCATE( workarr_sn(0:pg%nz+1,0:2,iplw:iprw) )
 !
 !--    Top boundary.
-       ALLOCATE( workarrc_t(0:2,jcsw:jcnw,iclw:icrw) )
+       ALLOCATE( workarr_t(0:2,jpsw:jpnw,iplw:iprw) )
 
     END SUBROUTINE pmci_allocate_workarrays
@@ -2000,29 +2066,27 @@
     SUBROUTINE pmci_create_workarray_exchange_datatypes
 !
-!--    Define specific MPI types for workarrc-exhchange.
+!--    Define specific MPI types for workarr-exchange.
        IMPLICIT NONE
 
-#if defined( __parallel )       
 !
 !--    For the left and right boundaries
-       CALL MPI_TYPE_VECTOR( 3, cg%nz+2, (jcnw-jcsw+1)*(cg%nz+2), MPI_REAL,     &
-            workarrc_lr_exchange_type, ierr )
-       CALL MPI_TYPE_COMMIT( workarrc_lr_exchange_type, ierr )
+       CALL MPI_TYPE_VECTOR( 3, pg%nz+2, (jpnw-jpsw+1)*(pg%nz+2), MPI_REAL,                         &
+            workarr_lr_exchange_type, ierr )
+       CALL MPI_TYPE_COMMIT( workarr_lr_exchange_type, ierr )
 !
 !--    For the south and north boundaries
-       CALL MPI_TYPE_VECTOR( 1, 3*(cg%nz+2), 3*(cg%nz+2), MPI_REAL,             &
-            workarrc_sn_exchange_type, ierr )
-       CALL MPI_TYPE_COMMIT( workarrc_sn_exchange_type, ierr )
+       CALL MPI_TYPE_VECTOR( 1, 3*(pg%nz+2), 3*(pg%nz+2), MPI_REAL,                                 &
+            workarr_sn_exchange_type, ierr )
+       CALL MPI_TYPE_COMMIT( workarr_sn_exchange_type, ierr )
 !
 !--    For the top-boundary x-slices
-       CALL MPI_TYPE_VECTOR( icrw-iclw+1, 3, 3*(jcnw-jcsw+1), MPI_REAL,         &
-            workarrc_t_exchange_type_x, ierr )
-       CALL MPI_TYPE_COMMIT( workarrc_t_exchange_type_x, ierr )
+       CALL MPI_TYPE_VECTOR( iprw-iplw+1, 3, 3*(jpnw-jpsw+1), MPI_REAL,                             &
+            workarr_t_exchange_type_x, ierr )
+       CALL MPI_TYPE_COMMIT( workarr_t_exchange_type_x, ierr )
 !
 !--    For the top-boundary y-slices
-       CALL MPI_TYPE_VECTOR( 1, 3*(jcnw-jcsw+1), 3*(jcnw-jcsw+1), MPI_REAL,     &
-            workarrc_t_exchange_type_y, ierr )
-       CALL MPI_TYPE_COMMIT( workarrc_t_exchange_type_y, ierr )
-#endif
+       CALL MPI_TYPE_VECTOR( 1, 3*(jpnw-jpsw+1), 3*(jpnw-jpsw+1), MPI_REAL,                         &
+            workarr_t_exchange_type_y, ierr )
+       CALL MPI_TYPE_COMMIT( workarr_t_exchange_type_y, ierr )
        
     END SUBROUTINE pmci_create_workarray_exchange_datatypes
@@ -2036,96 +2100,115 @@
 !--    the parent grid spacing in the respective direction. 
        IMPLICIT NONE
-       REAL(wp), PARAMETER :: tolefac = 1.0E-6_wp      !< Relative tolerence for grid-line matching
-       REAL(wp) :: pesdwx                              !< Child subdomain width in x-direction 
-       REAL(wp) :: pesdwy                              !< Child subdomain width in y-direction 
-       REAL(wp) :: tolex                               !< Tolerance for grid-line matching in x-direction
-       REAL(wp) :: toley                               !< Tolerance for grid-line matching in y-direction
-       REAL(wp) :: tolez                               !< Tolerance for grid-line matching in z-direction
-       INTEGER(iwp) :: non_matching_lower_left_corner  !< Flag for non-matching lower left corner
-       INTEGER(iwp) :: non_int_gsr_x                   !< Flag for non-integer grid-spacing ration in x-direction
-       INTEGER(iwp) :: non_int_gsr_y                   !< Flag for non-integer grid-spacing ration in y-direction
-       INTEGER(iwp) :: non_int_gsr_z                   !< Flag for non-integer grid-spacing ration in z-direction
-       INTEGER(iwp) :: too_narrow_pesd_x               !< Flag for too narrow pe-subdomain in x-direction
-       INTEGER(iwp) :: too_narrow_pesd_y               !< Flag for too narrow pe-subdomain in y-direction
-
-
-       non_matching_lower_left_corner = 0
-       non_int_gsr_x = 0
-       non_int_gsr_y = 0
-       non_int_gsr_z = 0
-       too_narrow_pesd_x = 0
-       too_narrow_pesd_y = 0
-
-       IF  ( myid == 0 )  THEN
+
+       INTEGER(iwp) ::  non_matching_height = 0              !< Flag for non-matching child-domain height
+       INTEGER(iwp) ::  non_matching_lower_left_corner = 0   !< Flag for non-matching lower left corner
+       INTEGER(iwp) ::  non_matching_upper_right_corner = 0  !< Flag for non-matching upper right corner
+       INTEGER(iwp) ::  non_int_gsr_x = 0                    !< Flag for non-integer grid-spacing ration in x-direction
+       INTEGER(iwp) ::  non_int_gsr_y = 0                    !< Flag for non-integer grid-spacing ration in y-direction
+       INTEGER(iwp) ::  non_int_gsr_z = 0                    !< Flag for non-integer grid-spacing ration in z-direction
+       INTEGER(iwp) ::  too_narrow_pesd_x = 0                !< Flag for too narrow pe-subdomain in x-direction
+       INTEGER(iwp) ::  too_narrow_pesd_y = 0                !< Flag for too narrow pe-subdomain in y-direction
+                                                         
+       REAL(wp), PARAMETER ::  tolefac = 1.0E-6_wp           !< Relative tolerence for grid-line matching
+                                                         
+       REAL(wp) ::  child_ngp_x_l                            !< Number of gridpoints in child subdomain in x-direction
+                                                             !< converted to REAL(wp) 
+       REAL(wp) ::  child_ngp_y_l                            !< Number of gridpoints in child subdomain in y-direction
+                                                             !< converted to REAL(wp)
+       REAL(wp) ::  tolex                                    !< Tolerance for grid-line matching in x-direction
+       REAL(wp) ::  toley                                    !< Tolerance for grid-line matching in y-direction
+       REAL(wp) ::  tolez                                    !< Tolerance for grid-line matching in z-direction
+       REAL(wp) ::  upper_right_coord_x                      !< X-coordinate of the upper right corner of the child domain
+       REAL(wp) ::  upper_right_coord_y                      !< Y-coordinate of the upper right corner of the child domain
+
+       
+       IF ( myid == 0 )  THEN
 
           tolex = tolefac * dx
           toley = tolefac * dy
-          tolez = tolefac * MINVAL( dzw )
-!
-!--       First check that the child grid lower left corner matches the paren grid lines.
-          IF  ( MOD( lower_left_coord_x, cg%dx ) > tolex ) non_matching_lower_left_corner = 1
-          IF  ( MOD( lower_left_coord_y, cg%dy ) > toley ) non_matching_lower_left_corner = 1
-!
-!--       Then check that the grid-spacing ratios in each direction are integer valued.    
-          IF  ( MOD( cg%dx, dx ) > tolex )  non_int_gsr_x = 1
-          IF  ( MOD( cg%dy, dy ) > toley )  non_int_gsr_y = 1
+          tolez = tolefac * dz(1)
+!
+!--       First check that the child domain lower left corner matches the parent grid lines.
+          IF ( MOD( lower_left_coord_x, pg%dx ) > tolex ) non_matching_lower_left_corner = 1
+          IF ( MOD( lower_left_coord_y, pg%dy ) > toley ) non_matching_lower_left_corner = 1
+!
+!--       Then check that the child doman upper right corner matches the parent grid lines.
+          upper_right_coord_x = lower_left_coord_x + ( nx + 1 ) * dx
+          upper_right_coord_y = lower_left_coord_y + ( ny + 1 ) * dy
+          IF ( MOD( upper_right_coord_x, pg%dx ) > tolex ) non_matching_upper_right_corner = 1
+          IF ( MOD( upper_right_coord_y, pg%dy ) > toley ) non_matching_upper_right_corner = 1
+!
+!--       Also check that the cild domain height matches the parent grid lines.
+          IF ( MOD( zw(nzt), pg%dz ) > tolez ) non_matching_height = 1
+!
+!--       Check that the grid-spacing ratios in each direction are integer valued.    
+          IF ( MOD( pg%dx, dx ) > tolex )  non_int_gsr_x = 1
+          IF ( MOD( pg%dy, dy ) > toley )  non_int_gsr_y = 1
+!
+!--       In the z-direction, all levels need to be checked separately against grid stretching  
+!--       which is not allowed.
           DO  n = 0, kctw+1
-             IF  ( ABS( cg%zw(n) - zw(kflw(n)) ) > tolez )  non_int_gsr_z = 1
+             IF ( ABS( pg%zw(n) - zw(kflw(n)) ) > tolez )  non_int_gsr_z = 1
           ENDDO
 
-          pesdwx = REAL( nxr - nxl + 1, KIND=wp )
-          IF  ( pesdwx / REAL( igsr, KIND=wp ) < 1.0_wp )  too_narrow_pesd_x = 1
-          pesdwy = REAL( nyn - nys + 1, KIND=wp )
-          IF  ( pesdwy / REAL( jgsr, KIND=wp ) < 1.0_wp )  too_narrow_pesd_y = 1
-                          
-       ENDIF
-
-       CALL MPI_BCAST( non_matching_lower_left_corner, 1, MPI_INTEGER, 0,       &
-            comm2d, ierr )
-       IF  ( non_matching_lower_left_corner > 0 )  THEN
-          WRITE ( message_string, * )  'nested child domain lower left ',       &
-               'corner must match its parent grid lines'
-          CALL message( 'pmci_check_grid_matching', 'PA0414', 3, 2, 0, 6, 0 )
-       ENDIF
-
-       CALL MPI_BCAST( non_int_gsr_x, 1, MPI_INTEGER, 0, comm2d, ierr )
-       IF  ( non_int_gsr_x > 0 )  THEN
-          WRITE ( message_string, * )  'nesting grid-spacing ratio ',           &
-               '( parent dx / child dx ) must have an integer value'
-          CALL message( 'pmci_check_grid_matching', 'PA0416', 3, 2, 0, 6, 0 )
-       ENDIF
-
-       CALL MPI_BCAST( non_int_gsr_y, 1, MPI_INTEGER, 0, comm2d, ierr )
-       IF  ( non_int_gsr_y > 0 )  THEN
-          WRITE ( message_string, * )  'nesting grid-spacing ratio ',           &
-               '( parent dy / child dy ) must have an integer value'
-          CALL message( 'pmci_check_grid_matching', 'PA0416', 3, 2, 0, 6, 0 )
-       ENDIF
-
-       CALL MPI_BCAST( non_int_gsr_z, 1, MPI_INTEGER, 0, comm2d, ierr )
-       IF  ( non_int_gsr_z > 0 )  THEN
-          WRITE ( message_string, * )  'nesting grid-spacing ratio ',           &
-               '( parent dz / child dz ) must have an integer value for each z-level'
-          CALL message( 'pmci_check_grid_matching', 'PA0416', 3, 2, 0, 6, 0 )
-       ENDIF    
-
-       CALL MPI_BCAST( too_narrow_pesd_x, 1, MPI_INTEGER, 0, comm2d, ierr )
-       IF  ( too_narrow_pesd_x > 0 )  THEN
-          WRITE ( message_string, * )  'child subdomain width in x-direction ',    &
-               'must not be smaller than its parent grid dx. Change the PE-grid ', &
-               'setting (npex, npey) to satisfy this requirement.'  
-          CALL message( 'pmci_check_grid_matching', 'PA0587', 3, 2, 0, 6, 0 )
-       ENDIF
+          child_ngp_x_l = REAL( nxr - nxl + 1, KIND=wp )
+          IF ( child_ngp_x_l / REAL( igsr, KIND=wp ) < 1.0_wp )  too_narrow_pesd_x = 1
+          child_ngp_y_l = REAL( nyn - nys + 1, KIND=wp )
+          IF ( child_ngp_y_l / REAL( jgsr, KIND=wp ) < 1.0_wp )  too_narrow_pesd_y = 1
+         
+          IF ( non_matching_height > 0 )  THEN
+             WRITE( message_string, * ) 'nested child domain height must match ',                   &
+                                        'its parent grid lines'
+             CALL message( 'pmci_check_grid_matching', 'PA0414', 3, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( non_matching_lower_left_corner > 0 )  THEN
+             WRITE( message_string, * ) 'nested child domain lower left ',                          &
+                                        'corner must match its parent grid lines'
+             CALL message( 'pmci_check_grid_matching', 'PA0414', 3, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( non_matching_upper_right_corner > 0 )  THEN
+             WRITE( message_string, * ) 'nested child domain upper right ',                         &
+                                        'corner must match its parent grid lines'
+             CALL message( 'pmci_check_grid_matching', 'PA0414', 3, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( non_int_gsr_x > 0 )  THEN
+             WRITE( message_string, * ) 'nesting grid-spacing ratio ( parent dx / child dx ) ',     &
+                                        'must have an integer value'
+             CALL message( 'pmci_check_grid_matching', 'PA0416', 3, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( non_int_gsr_y > 0 )  THEN
+             WRITE( message_string, * ) 'nesting grid-spacing ratio ( parent dy / child dy ) ',     &
+                                        'must have an integer value'
+             CALL message( 'pmci_check_grid_matching', 'PA0416', 3, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( non_int_gsr_z > 0 )  THEN
+             WRITE( message_string, * ) 'nesting grid-spacing ratio ( parent dz / child dz ) ',     &
+                                        'must have an integer value for each z-level'
+             CALL message( 'pmci_check_grid_matching', 'PA0416', 3, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( too_narrow_pesd_x > 0 )  THEN
+             WRITE( message_string, * ) 'child subdomain width in x-direction must not be ',        &
+                                        'smaller than its parent grid dx. Change the PE-grid ',     &
+                                        'setting (npex, npey) to satisfy this requirement.'  
+             CALL message( 'pmci_check_grid_matching', 'PA0587', 3, 2, 0, 6, 0 )
+          ENDIF
  
-       CALL MPI_BCAST( too_narrow_pesd_y, 1, MPI_INTEGER, 0, comm2d, ierr )
-       IF  ( too_narrow_pesd_y > 0 )  THEN
-          WRITE ( message_string, * )  'child subdomain width in y-direction ',    &
-               'must not be smaller than its parent grid dy. Change the PE-grid ', &
-               'setting (npex, npey) to satisfy this requirement.'  
-          CALL message( 'pmci_check_grid_matching', 'PA0587', 3, 2, 0, 6, 0 )
-       ENDIF       
-
-     END SUBROUTINE pmci_check_grid_matching
-
+          IF ( too_narrow_pesd_y > 0 )  THEN
+             WRITE( message_string, * ) 'child subdomain width in y-direction must not be ',        &
+                                        'smaller than its parent grid dy. Change the PE-grid ',     &
+                                        'setting (npex, npey) to satisfy this requirement.'  
+             CALL message( 'pmci_check_grid_matching', 'PA0587', 3, 2, 0, 6, 0 )
+          ENDIF
+                 
+       ENDIF  !  ( myid == 0 )
+       
+    END SUBROUTINE pmci_check_grid_matching
+     
 #endif  
  END SUBROUTINE pmci_setup_child
@@ -2203,14 +2286,11 @@
 !
 !-- Chemistry, depends on number of species
-    IF ( air_chemistry  .AND.  nest_chemistry )                                &
-       pmc_max_array = pmc_max_array + nspec
-!
-!-- Salsa, depens on the number aerosol size bins and chemical components + 
+    IF ( air_chemistry  .AND.  nest_chemistry )  pmc_max_array = pmc_max_array + nspec
+!
+!-- SALSA, depens on the number aerosol size bins and chemical components + 
 !-- the number of default gases
-    IF ( salsa  .AND.  nest_salsa )                                            &
-       pmc_max_array = pmc_max_array + nbins_aerosol + nbins_aerosol *         &
-                       ncomponents_mass
-       IF ( .NOT. salsa_gases_from_chem )  pmc_max_array = pmc_max_array +     &
-                                                           ngases_salsa
+    IF ( salsa  .AND.  nest_salsa )  pmc_max_array = pmc_max_array + nbins_aerosol +                &
+         nbins_aerosol * ncomponents_mass
+    IF ( .NOT. salsa_gases_from_chem )  pmc_max_array = pmc_max_array + ngases_salsa
 
 
@@ -2220,24 +2300,24 @@
 
 
-
- SUBROUTINE pmci_set_array_pointer( name, child_id, nz_cl, n )
+ SUBROUTINE pmci_set_array_pointer( name, child_id, nz_child, n )
 
     IMPLICIT NONE
-
-    INTEGER(iwp), INTENT(IN)          ::  child_id    !<
-    INTEGER(iwp), INTENT(IN)          ::  nz_cl       !<
-    INTEGER(iwp), INTENT(IN),OPTIONAL ::  n           !< index of chemical 
-                                                      !< species / salsa variables
-
+   
+    INTEGER(iwp), INTENT(IN) ::  child_id  !<
+    INTEGER(iwp), INTENT(IN) ::  nz_child  !<
+    
+    INTEGER(iwp), INTENT(IN), OPTIONAL ::  n          !< index of chemical species
+    
     CHARACTER(LEN=*), INTENT(IN) ::  name             !<
-
-#if defined( __parallel )
-    INTEGER(iwp) ::  ierr                            !< MPI error code
-
-    REAL(wp), POINTER, DIMENSION(:,:)     ::  p_2d        !<
-    REAL(wp), POINTER, DIMENSION(:,:,:)   ::  p_3d        !<
-    REAL(wp), POINTER, DIMENSION(:,:,:)   ::  p_3d_sec    !<
-    INTEGER(idp), POINTER, DIMENSION(:,:) ::  i_2d        !<
-
+!
+!-- Local variables:       
+    INTEGER(iwp) ::  ierr                             !< MPI error code
+
+    INTEGER(idp), POINTER, DIMENSION(:,:) ::  i_2d    !<
+       
+    REAL(wp), POINTER, DIMENSION(:,:)   ::  p_2d      !<
+    REAL(wp), POINTER, DIMENSION(:,:,:) ::  p_3d      !<
+    REAL(wp), POINTER, DIMENSION(:,:,:) ::  p_3d_sec  !<
+    
 
     NULLIFY( p_3d )
@@ -2267,6 +2347,6 @@
        p_3d => salsa_gas(n)%conc
 !
-!-- Next line is just an example for a 2D array (not active for coupling!)
-!-- Please note, that z0 has to be declared as TARGET array in modules.f90
+!-- Next line is just an example for a 2D array (not active for coupling!) 
+!-- Please note, that z0 has to be declared as TARGET array in modules.f90.
 !    IF ( TRIM(name) == "z0" )    p_2d => z0
     IF ( TRIM(name) == "u"    )  p_3d_sec => u_2
